# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`php`](#php): Base class with global configuration parameters that pulls in all enabled components.  === Parameters  [*ensure*]   Specify which version of 
* [`php::apache_config`](#php--apache_config): Install and configure php apache settings  === Parameters  [*inifile*]   The path to the ini php-apache ini file  [*settings*]   Hash with ne
* [`php::cli`](#php--cli): Install and configure php CLI  === Parameters  [*inifile*]   The path to the ini php5-cli ini file  [*settings*]   Hash with nested hash of k
* [`php::composer`](#php--composer): Install composer package manager  === Parameters  [*source*]   Holds URL to the Composer source file  [*path*]   Holds path to the Composer e
* [`php::composer::auto_update`](#php--composer--auto_update): Install composer package manager  === Parameters  [*max_age*]   Defines number of days after which Composer should be updated  [*source*]   H
* [`php::dev`](#php--dev): Install the development package with headers for PHP  === Parameters  [*ensure*]   The PHP ensure of PHP dev to install  [*package*]   The pa
* [`php::embedded`](#php--embedded): Install and configure php embedded SAPI  === Parameters  [*inifile*]   The path to the ini php5-embeded ini file  [*settings*]   Hash with ne
* [`php::fpm`](#php--fpm): Install and configure mod_php for fpm  === Parameters  [*user*]   The user that php-fpm should run as  [*group*]   The group that php-fpm sho
* [`php::fpm::config`](#php--fpm--config): Configure php-fpm service  === Parameters  [*config_file*]   The path to the fpm config file  [*user*]   The user that runs php-fpm  [*group*
* [`php::fpm::service`](#php--fpm--service): Manage fpm service  === Parameters  [*service_name*]   name of the php-fpm service  [*ensure*]   'ensure' value for the service  [*enable*]  
* [`php::global`](#php--global)
* [`php::globals`](#php--globals)
* [`php::packages`](#php--packages): Install common PHP packages  === Parameters  [*ensure*]   Specify which version of PHP packages to install  [*names*]   List of the names of 
* [`php::params`](#php--params): PHP params class
* [`php::pear`](#php--pear): Install PEAR package manager  === Parameters  [*ensure*]   The package ensure of PHP pear to install and run pear auto_discover  [*package*] 
* [`php::phpunit`](#php--phpunit): Install phpunit, PHP testing framework  === Parameters  [*source*]   Holds URL to the phpunit source file  [*path*]   Holds path to the phpun
* [`php::phpunit::auto_update`](#php--phpunit--auto_update): Install phpunit package manager  === Parameters  [*max_age*]   Defines number of days after which phpunit should be updated  [*source*]   Hol
* [`php::repo`](#php--repo): Configure package repository
* [`php::repo::debian`](#php--repo--debian): Configure debian apt repo  === Parameters  [*location*]   Location of the apt repository  [*repos*]   Apt repository names  [*include_src*]  
* [`php::repo::redhat`](#php--repo--redhat)
* [`php::repo::suse`](#php--repo--suse): Configure suse repo  === Parameters  [*reponame*]   Name of the Zypper repository  [*baseurl*]   Base URL of the Zypper repository
* [`php::repo::ubuntu`](#php--repo--ubuntu): Configure ubuntu ppa  === Parameters  [*version*]   PHP version to manage (e.g. 5.6)

### Defined types

* [`php::apache_vhost`](#php--apache_vhost): Configures an apache vhost for php  === Parameters  [*vhost*]   The vhost address  [*docroot*]   The vhost docroot  [*port*]   The vhost port
* [`php::config`](#php--config): Configure php.ini settings for a PHP SAPI  === Parameters  [*file*]   The path to ini file  [*config*]   Nested hash of key => value to apply
* [`php::config::setting`](#php--config--setting): Configure php.ini settings  === Parameters  [*key*]   The key of the value, like `ini_setting`  [*file*]   The path to ini file  [*value*]   
* [`php::extension`](#php--extension): Install a PHP extension package  === Parameters  [*ensure*]   The ensure of the package to install   Could be "present", "absent", "latest", 
* [`php::extension::config`](#php--extension--config): Configure a PHP extension package  === Parameters  [*ensure*]   The ensure of the package to install   Could be "latest", "installed" or a pi
* [`php::extension::install`](#php--extension--install): Install a PHP extension package  === Parameters  [*ensure*]   The ensure of the package to install   Could be "latest", "installed" or a pinn
* [`php::fpm::pool`](#php--fpm--pool): Configure fpm pools  === Parameters  See the official php-fpm documentation for parameters that are not documented here: http://php.net/manua

### Functions

* [`ensure_prefix`](#ensure_prefix): This function ensures a prefix for all elements in an array or the keys in a hash.  *Examples:*    ensure_prefix({'a' => 1, 'b' => 2, 'p.c' =
* [`to_hash_settings`](#to_hash_settings): This function converts a +{key => value}+ hash into a nested hash and can add an id to the outer key. The optional id string as second parame

### Data types

* [`Php::ComposerChannel`](#Php--ComposerChannel)
* [`Php::Duration`](#Php--Duration): A duration in seconds are with an unit
* [`Php::InstallOptions`](#Php--InstallOptions)
* [`Php::Provider`](#Php--Provider)
* [`Php::Sapi`](#Php--Sapi)

## Classes

### <a name="php"></a>`php`

Base class with global configuration parameters that pulls in all
enabled components.

=== Parameters

[*ensure*]
  Specify which version of PHP packages to install, defaults to 'present'.
  Please note that 'absent' to remove packages is not supported!

[*manage_repos*]
  Include repository (dotdeb, ppa, etc.) to install recent PHP from

[*fpm*]
  Install and configure php-fpm

[*fpm_service_enable*]
  Enable/disable FPM service

[*fpm_service_ensure*]
  Ensure FPM service is either 'running' or 'stopped'

[*fpm_service_name*]
  This is the name of the php-fpm service. It defaults to reasonable OS
  defaults but can be different in case of using php7.0/other OS/custom fpm service

[*fpm_service_provider*]
  This is the name of the service provider, in case there is a non
  OS default service provider used to start FPM.
  Defaults to 'undef', pick system defaults.

[*fpm_pools*]
  Hash of php::fpm::pool resources that will be created. Defaults
  to a single php::fpm::pool named www with default parameters.

[*fpm_global_pool_settings*]
  Hash of defaults params php::fpm::pool resources that will be created.
  Defaults to empty hash.

[*fpm_inifile*]
  Path to php.ini for fpm

[*fpm_package*]
  Name of fpm package to install

[*fpm_user*]
  The user that php-fpm should run as

[*fpm_group*]
  The group that php-fpm should run as

[*dev*]
  Install php header files, needed to install pecl modules

[*composer*]
  Install and auto-update composer

[*pear*]
  Install PEAR

[*phpunit*]
  Install phpunit

[*apache_config*]
  Manage apache's mod_php configuration

[*proxy_type*]
   proxy server type (none|http|https|ftp)

[*proxy_server*]
  specify a proxy server, with port number if needed. ie: https://example.com:8080.

[*extensions*]
  Install PHP extensions, this is overwritten by hiera hash `php::extensions`

[*package_prefix*]
  This is the prefix for constructing names of php packages. This defaults
  to a sensible default depending on your operating system, like 'php-' or
  'php5-'.

[*config_root_ini*]
  This is the path to the config .ini files of the extensions. This defaults
  to a sensible default depending on your operating system, like
  '/etc/php5/mods-available' or '/etc/php5/conf.d'.

[*config_root_inifile*]
  The path to the global php.ini file. This defaults to a sensible default
  depending on your operating system.

[*ext_tool_enable*]
  Absolute path to php tool for enabling extensions in debian/ubuntu systems.
  This defaults to '/usr/sbin/php5enmod'.

[*ext_tool_query*]
  Absolute path to php tool for querying information about extensions in
  debian/ubuntu systems. This defaults to '/usr/sbin/php5query'.

[*ext_tool_enabled*]
  Enable or disable the use of php tools on debian based systems
  debian/ubuntu systems. This defaults to 'true'.

[*log_owner*]
  The php-fpm log owner

[*log_group*]
  The group owning php-fpm logs

[*embedded*]
  Enable embedded SAPI

[*pear_ensure*]
  The package ensure of PHP pear to install and run pear auto_discover

[*settings*]
  PHP configuration parameters in php.ini files as a hash. For example,
  'Date/date.timezone' => 'Australia/Melbourne' sets data.timezone
  to 'Australia/Melbourne' under [Date] section, and
  'PHP/memory_limit' => '256M' sets memory_limit to 256M.

[*cli_settings*]
  Additional hash of PHP configuration parameters for PHP CLI. When a
  setting key already exists in $settings, the value provided from the
  $cli_settings parameter overrides the value from $settings parameter.
  For example, 'PHP/memory_limit' => '1000M' sets memory_limit to 1000M
  for the PHP cli ini file, regardless of the values from $settings.

[*pool_purge*]
  Whether to purge pool config files not created
  by this module

[*reload_fpm_on_config_changes*]
  by default, we reload the service on changes.
  But certain options, like socket owner, will only be applied during a restart.
  If set to false, a restart will be executed instead of a reload.
  This default will be changed in a future release.

#### Parameters

The following parameters are available in the `php` class:

* [`ensure`](#-php--ensure)
* [`manage_repos`](#-php--manage_repos)
* [`fpm`](#-php--fpm)
* [`fpm_service_enable`](#-php--fpm_service_enable)
* [`fpm_service_ensure`](#-php--fpm_service_ensure)
* [`fpm_service_name`](#-php--fpm_service_name)
* [`fpm_service_provider`](#-php--fpm_service_provider)
* [`fpm_pools`](#-php--fpm_pools)
* [`fpm_global_pool_settings`](#-php--fpm_global_pool_settings)
* [`fpm_inifile`](#-php--fpm_inifile)
* [`fpm_package`](#-php--fpm_package)
* [`fpm_user`](#-php--fpm_user)
* [`fpm_group`](#-php--fpm_group)
* [`fpm_log_dir_mode`](#-php--fpm_log_dir_mode)
* [`embedded`](#-php--embedded)
* [`dev`](#-php--dev)
* [`composer`](#-php--composer)
* [`pear`](#-php--pear)
* [`pear_ensure`](#-php--pear_ensure)
* [`phpunit`](#-php--phpunit)
* [`apache_config`](#-php--apache_config)
* [`proxy_type`](#-php--proxy_type)
* [`proxy_server`](#-php--proxy_server)
* [`extensions`](#-php--extensions)
* [`settings`](#-php--settings)
* [`cli_settings`](#-php--cli_settings)
* [`package_prefix`](#-php--package_prefix)
* [`config_root_ini`](#-php--config_root_ini)
* [`config_root_inifile`](#-php--config_root_inifile)
* [`ext_tool_enable`](#-php--ext_tool_enable)
* [`ext_tool_query`](#-php--ext_tool_query)
* [`ext_tool_enabled`](#-php--ext_tool_enabled)
* [`log_owner`](#-php--log_owner)
* [`log_group`](#-php--log_group)
* [`pool_purge`](#-php--pool_purge)
* [`reload_fpm_on_config_changes`](#-php--reload_fpm_on_config_changes)

##### <a name="-php--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::params::ensure`

##### <a name="-php--manage_repos"></a>`manage_repos`

Data type: `Boolean`



Default value: `$php::params::manage_repos`

##### <a name="-php--fpm"></a>`fpm`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--fpm_service_enable"></a>`fpm_service_enable`

Data type: `Boolean`



Default value: `$php::params::fpm_service_enable`

##### <a name="-php--fpm_service_ensure"></a>`fpm_service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `$php::params::fpm_service_ensure`

##### <a name="-php--fpm_service_name"></a>`fpm_service_name`

Data type: `String[1]`



Default value: `$php::params::fpm_service_name`

##### <a name="-php--fpm_service_provider"></a>`fpm_service_provider`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm_pools"></a>`fpm_pools`

Data type: `Hash`



Default value: `$php::params::fpm_pools`

##### <a name="-php--fpm_global_pool_settings"></a>`fpm_global_pool_settings`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm_inifile"></a>`fpm_inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::fpm_inifile`

##### <a name="-php--fpm_package"></a>`fpm_package`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm_user"></a>`fpm_user`

Data type: `String[1]`



Default value: `$php::params::fpm_user`

##### <a name="-php--fpm_group"></a>`fpm_group`

Data type: `String[1]`



Default value: `$php::params::fpm_group`

##### <a name="-php--fpm_log_dir_mode"></a>`fpm_log_dir_mode`

Data type: `Stdlib::Filemode`



Default value: `$php::params::fpm_log_dir_mode`

##### <a name="-php--embedded"></a>`embedded`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--dev"></a>`dev`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--composer"></a>`composer`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--pear"></a>`pear`

Data type: `Boolean`



Default value: `$php::params::pear`

##### <a name="-php--pear_ensure"></a>`pear_ensure`

Data type: `String`



Default value: `$php::params::pear_ensure`

##### <a name="-php--phpunit"></a>`phpunit`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--apache_config"></a>`apache_config`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--proxy_type"></a>`proxy_type`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--proxy_server"></a>`proxy_server`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--extensions"></a>`extensions`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--cli_settings"></a>`cli_settings`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--package_prefix"></a>`package_prefix`

Data type: `Optional[String[1]]`



Default value: `$php::params::package_prefix`

##### <a name="-php--config_root_ini"></a>`config_root_ini`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::config_root_ini`

##### <a name="-php--config_root_inifile"></a>`config_root_inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::config_root_inifile`

##### <a name="-php--ext_tool_enable"></a>`ext_tool_enable`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$php::params::ext_tool_enable`

##### <a name="-php--ext_tool_query"></a>`ext_tool_query`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$php::params::ext_tool_query`

##### <a name="-php--ext_tool_enabled"></a>`ext_tool_enabled`

Data type: `Boolean`



Default value: `$php::params::ext_tool_enabled`

##### <a name="-php--log_owner"></a>`log_owner`

Data type: `String`



Default value: `$php::params::fpm_user`

##### <a name="-php--log_group"></a>`log_group`

Data type: `String`



Default value: `$php::params::fpm_group`

##### <a name="-php--pool_purge"></a>`pool_purge`

Data type: `Boolean`



Default value: `$php::params::pool_purge`

##### <a name="-php--reload_fpm_on_config_changes"></a>`reload_fpm_on_config_changes`

Data type: `Boolean`



Default value: `true`

### <a name="php--apache_config"></a>`php::apache_config`

Install and configure php apache settings

=== Parameters

[*inifile*]
  The path to the ini php-apache ini file

[*settings*]
  Hash with nested hash of key => value to set in inifile

#### Parameters

The following parameters are available in the `php::apache_config` class:

* [`inifile`](#-php--apache_config--inifile)
* [`settings`](#-php--apache_config--settings)

##### <a name="-php--apache_config--inifile"></a>`inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::apache_inifile`

##### <a name="-php--apache_config--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

### <a name="php--cli"></a>`php::cli`

Install and configure php CLI

=== Parameters

[*inifile*]
  The path to the ini php5-cli ini file

[*settings*]
  Hash with nested hash of key => value to set in inifile

#### Parameters

The following parameters are available in the `php::cli` class:

* [`inifile`](#-php--cli--inifile)
* [`settings`](#-php--cli--settings)

##### <a name="-php--cli--inifile"></a>`inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::cli_inifile`

##### <a name="-php--cli--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

### <a name="php--composer"></a>`php::composer`

Install composer package manager

=== Parameters

[*source*]
  Holds URL to the Composer source file

[*path*]
  Holds path to the Composer executable

[*channel*]
  Holds the Update channel (stable|preview|snapshot|1|2)

[*proxy_type*]
   proxy server type (none|http|https|ftp)

[*proxy_server*]
  specify a proxy server, with port number if needed. ie: https://example.com:8080.

[*auto_update*]
  Defines if composer should be auto updated

[*max_age*]
  Defines the time in days after which an auto-update gets executed

[*root_group*]
  UNIX group of the root user

#### Parameters

The following parameters are available in the `php::composer` class:

* [`source`](#-php--composer--source)
* [`path`](#-php--composer--path)
* [`proxy_type`](#-php--composer--proxy_type)
* [`proxy_server`](#-php--composer--proxy_server)
* [`channel`](#-php--composer--channel)
* [`auto_update`](#-php--composer--auto_update)
* [`max_age`](#-php--composer--max_age)
* [`root_group`](#-php--composer--root_group)

##### <a name="-php--composer--source"></a>`source`

Data type: `String`



Default value: `$php::params::composer_source`

##### <a name="-php--composer--path"></a>`path`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::composer_path`

##### <a name="-php--composer--proxy_type"></a>`proxy_type`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--composer--proxy_server"></a>`proxy_server`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--composer--channel"></a>`channel`

Data type: `Php::ComposerChannel`



Default value: `'stable'`

##### <a name="-php--composer--auto_update"></a>`auto_update`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--composer--max_age"></a>`max_age`

Data type: `Integer`



Default value: `$php::params::composer_max_age`

##### <a name="-php--composer--root_group"></a>`root_group`

Data type: `Variant[Integer, String]`



Default value: `$php::params::root_group`

### <a name="php--composer--auto_update"></a>`php::composer::auto_update`

Install composer package manager

=== Parameters

[*max_age*]
  Defines number of days after which Composer should be updated

[*source*]
  Holds URL to the Composer source file

[*path*]
  Holds path to the Composer executable

[*channel*]
  Holds the Update channel (stable|preview|snapshot|1|2)

[*proxy_type*]
   proxy server type (none|http|https|ftp)

[*proxy_server*]
  specify a proxy server, with port number if needed. ie: https://example.com:8080.


=== Examples

 include php::composer::auto_update
 class { "php::composer::auto_update":
   "max_age" => 90
 }

#### Parameters

The following parameters are available in the `php::composer::auto_update` class:

* [`max_age`](#-php--composer--auto_update--max_age)
* [`source`](#-php--composer--auto_update--source)
* [`path`](#-php--composer--auto_update--path)
* [`channel`](#-php--composer--auto_update--channel)
* [`proxy_type`](#-php--composer--auto_update--proxy_type)
* [`proxy_server`](#-php--composer--auto_update--proxy_server)

##### <a name="-php--composer--auto_update--max_age"></a>`max_age`

Data type: `Integer[1]`



##### <a name="-php--composer--auto_update--source"></a>`source`

Data type: `String[1]`



##### <a name="-php--composer--auto_update--path"></a>`path`

Data type: `Stdlib::Absolutepath`



##### <a name="-php--composer--auto_update--channel"></a>`channel`

Data type: `Php::ComposerChannel`



Default value: `'stable'`

##### <a name="-php--composer--auto_update--proxy_type"></a>`proxy_type`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--composer--auto_update--proxy_server"></a>`proxy_server`

Data type: `Optional[String[1]]`



Default value: `undef`

### <a name="php--dev"></a>`php::dev`

Install the development package with headers for PHP

=== Parameters

[*ensure*]
  The PHP ensure of PHP dev to install

[*package*]
  The package name for the PHP development files

#### Parameters

The following parameters are available in the `php::dev` class:

* [`ensure`](#-php--dev--ensure)
* [`package`](#-php--dev--package)
* [`manage_repos`](#-php--dev--manage_repos)

##### <a name="-php--dev--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::ensure`

##### <a name="-php--dev--package"></a>`package`

Data type: `String`



Default value: `"${php::package_prefix}${php::params::dev_package_suffix}"`

##### <a name="-php--dev--manage_repos"></a>`manage_repos`

Data type: `Boolean`



Default value: `$php::manage_repos`

### <a name="php--embedded"></a>`php::embedded`

Install and configure php embedded SAPI

=== Parameters

[*inifile*]
  The path to the ini php5-embeded ini file

[*settings*]
  Hash with nested hash of key => value to set in inifile

[*package*]
  Specify which package to install

[*ensure*]
  Specify which version of the package to install

#### Parameters

The following parameters are available in the `php::embedded` class:

* [`ensure`](#-php--embedded--ensure)
* [`package`](#-php--embedded--package)
* [`inifile`](#-php--embedded--inifile)
* [`settings`](#-php--embedded--settings)

##### <a name="-php--embedded--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::ensure`

##### <a name="-php--embedded--package"></a>`package`

Data type: `String`



Default value: `"${php::package_prefix}${php::params::embedded_package_suffix}"`

##### <a name="-php--embedded--inifile"></a>`inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::embedded_inifile`

##### <a name="-php--embedded--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

### <a name="php--fpm"></a>`php::fpm`

Install and configure mod_php for fpm

=== Parameters

[*user*]
  The user that php-fpm should run as

[*group*]
  The group that php-fpm should run as

[*service_enable*]
  Enable/disable FPM service

[*service_ensure*]
  Ensure FPM service is either 'running' or 'stopped'

[*service_name*]
  This is the name of the php-fpm service. It defaults to reasonable OS
  defaults but can be different in case of using php7.0/other OS/custom fpm service

[*service_provider*]
  This is the name of the service provider, in case there is a non
  OS default service provider used to start FPM.
  Defaults to 'undef', pick system defaults.

[*pools*]
  Hash of php::fpm::pool resources that will be created. Defaults
  to a single php::fpm::pool named www with default parameters.

[*log_owner*]
  The php-fpm log owner

[*log_group*]
  The group owning php-fpm logs

[*package*]
  Specify which package to install

[*ensure*]
  Specify which version of the package to install

[*inifile*]
  Path to php.ini for fpm

[*settings*]
  fpm settings hash

[*global_pool_settings*]
  Hash of defaults params php::fpm::pool resources that will be created.
  Defaults is empty hash.

[*pool_purge*]
  Whether to purge pool config files not created
  by this module

[*reload_fpm_on_config_changes*]
  by default, we reload the service on changes.
  But certain options, like socket owner, will only be applied during a restart.
  If set to false, a restart will be executed instead of a reload.
  This default will be changed in a future release.

#### Parameters

The following parameters are available in the `php::fpm` class:

* [`ensure`](#-php--fpm--ensure)
* [`user`](#-php--fpm--user)
* [`group`](#-php--fpm--group)
* [`service_ensure`](#-php--fpm--service_ensure)
* [`service_enable`](#-php--fpm--service_enable)
* [`service_name`](#-php--fpm--service_name)
* [`service_provider`](#-php--fpm--service_provider)
* [`package`](#-php--fpm--package)
* [`inifile`](#-php--fpm--inifile)
* [`settings`](#-php--fpm--settings)
* [`global_pool_settings`](#-php--fpm--global_pool_settings)
* [`pools`](#-php--fpm--pools)
* [`log_owner`](#-php--fpm--log_owner)
* [`log_group`](#-php--fpm--log_group)
* [`pool_purge`](#-php--fpm--pool_purge)
* [`reload_fpm_on_config_changes`](#-php--fpm--reload_fpm_on_config_changes)

##### <a name="-php--fpm--ensure"></a>`ensure`

Data type: `Optional[String]`



Default value: `$php::ensure`

##### <a name="-php--fpm--user"></a>`user`

Data type: `String[1]`



Default value: `$php::fpm_user`

##### <a name="-php--fpm--group"></a>`group`

Data type: `String[1]`



Default value: `$php::fpm_group`

##### <a name="-php--fpm--service_ensure"></a>`service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `$php::fpm_service_ensure`

##### <a name="-php--fpm--service_enable"></a>`service_enable`

Data type: `Boolean`



Default value: `$php::fpm_service_enable`

##### <a name="-php--fpm--service_name"></a>`service_name`

Data type: `String[1]`



Default value: `$php::fpm_service_name`

##### <a name="-php--fpm--service_provider"></a>`service_provider`

Data type: `Optional[String[1]]`



Default value: `$php::fpm_service_provider`

##### <a name="-php--fpm--package"></a>`package`

Data type: `String`



Default value: `$php::real_fpm_package`

##### <a name="-php--fpm--inifile"></a>`inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::fpm_inifile`

##### <a name="-php--fpm--settings"></a>`settings`

Data type: `Hash`



Default value: `$php::real_settings`

##### <a name="-php--fpm--global_pool_settings"></a>`global_pool_settings`

Data type: `Hash`



Default value: `$php::real_fpm_global_pool_settings`

##### <a name="-php--fpm--pools"></a>`pools`

Data type: `Hash`



Default value: `$php::real_fpm_pools`

##### <a name="-php--fpm--log_owner"></a>`log_owner`

Data type: `String[1]`



Default value: `$php::log_owner`

##### <a name="-php--fpm--log_group"></a>`log_group`

Data type: `String[1]`



Default value: `$php::log_group`

##### <a name="-php--fpm--pool_purge"></a>`pool_purge`

Data type: `Boolean`



Default value: `$php::pool_purge`

##### <a name="-php--fpm--reload_fpm_on_config_changes"></a>`reload_fpm_on_config_changes`

Data type: `Boolean`



Default value: `$php::reload_fpm_on_config_changes`

### <a name="php--fpm--config"></a>`php::fpm::config`

Configure php-fpm service

=== Parameters

[*config_file*]
  The path to the fpm config file

[*user*]
  The user that runs php-fpm

[*group*]
  The group that runs php-fpm

[*inifile*]
  The path to ini file

[*settings*]
  Nested hash of key => value to apply to php.ini

[*pool_base_dir*]
  The folder that contains the php-fpm pool configs

[*pool_purge*]
  Whether to purge pool config files not created
  by this module

[*error_log*]
  Path to error log file. If it's set to "syslog", log is
  sent to syslogd instead of being written in a local file.

[*log_level*]
  The php-fpm log level

[*emergency_restart_threshold*]
  The php-fpm emergency_restart_threshold

[*emergency_restart_interval*]
  The php-fpm emergency_restart_interval

[*process_control_timeout*]
  The php-fpm process_control_timeout

[*process_max*]
  The maximum number of processes FPM will fork.

[*rlimit_files*]
  Set open file descriptor rlimit for the master process.

[*systemd_interval*]
  The interval between health report notification to systemd

[*log_owner*]
  The php-fpm log owner

[*log_group*]
  The group owning php-fpm logs

[*log_dir_mode*]
  The octal mode of the directory

[*syslog_facility*]
  Used to specify what type of program is logging the message

[*syslog_ident*]
  Prepended to every message

[*root_group*]
  UNIX group of the root user

[*pid_file*]
  Path to fpm pid file

[*manage_run_dir*]
  Manage the run directory

#### Parameters

The following parameters are available in the `php::fpm::config` class:

* [`config_file`](#-php--fpm--config--config_file)
* [`user`](#-php--fpm--config--user)
* [`group`](#-php--fpm--config--group)
* [`inifile`](#-php--fpm--config--inifile)
* [`pid_file`](#-php--fpm--config--pid_file)
* [`settings`](#-php--fpm--config--settings)
* [`pool_base_dir`](#-php--fpm--config--pool_base_dir)
* [`pool_purge`](#-php--fpm--config--pool_purge)
* [`error_log`](#-php--fpm--config--error_log)
* [`log_level`](#-php--fpm--config--log_level)
* [`emergency_restart_threshold`](#-php--fpm--config--emergency_restart_threshold)
* [`emergency_restart_interval`](#-php--fpm--config--emergency_restart_interval)
* [`process_control_timeout`](#-php--fpm--config--process_control_timeout)
* [`process_max`](#-php--fpm--config--process_max)
* [`rlimit_files`](#-php--fpm--config--rlimit_files)
* [`systemd_interval`](#-php--fpm--config--systemd_interval)
* [`log_owner`](#-php--fpm--config--log_owner)
* [`log_group`](#-php--fpm--config--log_group)
* [`log_dir_mode`](#-php--fpm--config--log_dir_mode)
* [`root_group`](#-php--fpm--config--root_group)
* [`syslog_facility`](#-php--fpm--config--syslog_facility)
* [`syslog_ident`](#-php--fpm--config--syslog_ident)
* [`manage_run_dir`](#-php--fpm--config--manage_run_dir)

##### <a name="-php--fpm--config--config_file"></a>`config_file`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::fpm_config_file`

##### <a name="-php--fpm--config--user"></a>`user`

Data type: `String`



Default value: `$php::params::fpm_user`

##### <a name="-php--fpm--config--group"></a>`group`

Data type: `String`



Default value: `$php::params::fpm_group`

##### <a name="-php--fpm--config--inifile"></a>`inifile`

Data type: `String`



Default value: `$php::params::fpm_inifile`

##### <a name="-php--fpm--config--pid_file"></a>`pid_file`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::fpm_pid_file`

##### <a name="-php--fpm--config--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--config--pool_base_dir"></a>`pool_base_dir`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::fpm_pool_dir`

##### <a name="-php--fpm--config--pool_purge"></a>`pool_purge`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--fpm--config--error_log"></a>`error_log`

Data type: `String`



Default value: `$php::params::fpm_error_log`

##### <a name="-php--fpm--config--log_level"></a>`log_level`

Data type: `String`



Default value: `'notice'`

##### <a name="-php--fpm--config--emergency_restart_threshold"></a>`emergency_restart_threshold`

Data type: `Integer`



Default value: `0`

##### <a name="-php--fpm--config--emergency_restart_interval"></a>`emergency_restart_interval`

Data type: `Php::Duration`



Default value: `0`

##### <a name="-php--fpm--config--process_control_timeout"></a>`process_control_timeout`

Data type: `Php::Duration`



Default value: `0`

##### <a name="-php--fpm--config--process_max"></a>`process_max`

Data type: `Integer`



Default value: `0`

##### <a name="-php--fpm--config--rlimit_files"></a>`rlimit_files`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-php--fpm--config--systemd_interval"></a>`systemd_interval`

Data type: `Optional[Php::Duration]`



Default value: `undef`

##### <a name="-php--fpm--config--log_owner"></a>`log_owner`

Data type: `String`



Default value: `$php::params::fpm_user`

##### <a name="-php--fpm--config--log_group"></a>`log_group`

Data type: `String`



Default value: `$php::params::fpm_group`

##### <a name="-php--fpm--config--log_dir_mode"></a>`log_dir_mode`

Data type: `Stdlib::Filemode`



Default value: `$php::params::fpm_log_dir_mode`

##### <a name="-php--fpm--config--root_group"></a>`root_group`

Data type: `String[1]`



Default value: `$php::params::root_group`

##### <a name="-php--fpm--config--syslog_facility"></a>`syslog_facility`

Data type: `String`



Default value: `'daemon'`

##### <a name="-php--fpm--config--syslog_ident"></a>`syslog_ident`

Data type: `String`



Default value: `'php-fpm'`

##### <a name="-php--fpm--config--manage_run_dir"></a>`manage_run_dir`

Data type: `Boolean`



Default value: `true`

### <a name="php--fpm--service"></a>`php::fpm::service`

Manage fpm service

=== Parameters

[*service_name*]
  name of the php-fpm service

[*ensure*]
  'ensure' value for the service

[*enable*]
  Defines if the service is enabled

[*provider*]
  Defines if the service provider to use

[*reload_fpm_on_config_changes*]
  by default, we reload the service on changes.
  But certain options, like socket owner, will only be applied during a restart.
  If set to false, a restart will be executed instead of a reload.
  This default will be changed in a future release.

#### Parameters

The following parameters are available in the `php::fpm::service` class:

* [`service_name`](#-php--fpm--service--service_name)
* [`ensure`](#-php--fpm--service--ensure)
* [`enable`](#-php--fpm--service--enable)
* [`provider`](#-php--fpm--service--provider)
* [`reload_fpm_on_config_changes`](#-php--fpm--service--reload_fpm_on_config_changes)

##### <a name="-php--fpm--service--service_name"></a>`service_name`

Data type: `String[1]`



Default value: `$php::fpm::service_name`

##### <a name="-php--fpm--service--ensure"></a>`ensure`

Data type: `Enum['running', 'stopped']`



Default value: `$php::fpm::service_ensure`

##### <a name="-php--fpm--service--enable"></a>`enable`

Data type: `Boolean`



Default value: `$php::fpm::service_enable`

##### <a name="-php--fpm--service--provider"></a>`provider`

Data type: `Optional[String[1]]`



Default value: `$php::fpm::service_provider`

##### <a name="-php--fpm--service--reload_fpm_on_config_changes"></a>`reload_fpm_on_config_changes`

Data type: `Boolean`



Default value: `$php::fpm::reload_fpm_on_config_changes`

### <a name="php--global"></a>`php::global`

The php::global class.

#### Parameters

The following parameters are available in the `php::global` class:

* [`inifile`](#-php--global--inifile)
* [`settings`](#-php--global--settings)

##### <a name="-php--global--inifile"></a>`inifile`

Data type: `Stdlib::Absolutepath`



Default value: `$php::config_root_inifile`

##### <a name="-php--global--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

### <a name="php--globals"></a>`php::globals`

The php::globals class.

#### Parameters

The following parameters are available in the `php::globals` class:

* [`php_version`](#-php--globals--php_version)
* [`config_root`](#-php--globals--config_root)
* [`fpm_pid_file`](#-php--globals--fpm_pid_file)
* [`rhscl_mode`](#-php--globals--rhscl_mode)
* [`zend_creds`](#-php--globals--zend_creds)
* [`flavor`](#-php--globals--flavor)

##### <a name="-php--globals--php_version"></a>`php_version`

Data type: `Optional[Pattern[/^(rh-)?(php)?[578](\.)?[0-9]/]]`



Default value: `undef`

##### <a name="-php--globals--config_root"></a>`config_root`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--globals--fpm_pid_file"></a>`fpm_pid_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--globals--rhscl_mode"></a>`rhscl_mode`

Data type: `Optional[Enum['rhscl', 'remi']]`



Default value: `undef`

##### <a name="-php--globals--zend_creds"></a>`zend_creds`

Data type: `Optional[Hash]`



Default value: `undef`

##### <a name="-php--globals--flavor"></a>`flavor`

Data type: `Enum['community', 'zend']`



Default value: `'community'`

### <a name="php--packages"></a>`php::packages`

Install common PHP packages

=== Parameters

[*ensure*]
  Specify which version of PHP packages to install

[*names*]
  List of the names of the package to install

[*names_to_prefix*]
  List of packages names that should be prefixed with the common
  package prefix `$php::package_prefix`

#### Parameters

The following parameters are available in the `php::packages` class:

* [`ensure`](#-php--packages--ensure)
* [`manage_repos`](#-php--packages--manage_repos)
* [`names_to_prefix`](#-php--packages--names_to_prefix)
* [`names`](#-php--packages--names)

##### <a name="-php--packages--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::ensure`

##### <a name="-php--packages--manage_repos"></a>`manage_repos`

Data type: `Boolean`



Default value: `$php::manage_repos`

##### <a name="-php--packages--names_to_prefix"></a>`names_to_prefix`

Data type: `Array`



Default value: `prefix($php::params::common_package_suffixes, $php::package_prefix)`

##### <a name="-php--packages--names"></a>`names`

Data type: `Array`



Default value: `$php::params::common_package_names`

### <a name="php--params"></a>`php::params`

PHP params class

### <a name="php--pear"></a>`php::pear`

Install PEAR package manager

=== Parameters

[*ensure*]
  The package ensure of PHP pear to install and run pear auto_discover

[*package*]
  The package name for PHP pear

#### Parameters

The following parameters are available in the `php::pear` class:

* [`ensure`](#-php--pear--ensure)
* [`package`](#-php--pear--package)
* [`manage_repos`](#-php--pear--manage_repos)

##### <a name="-php--pear--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::pear_ensure`

##### <a name="-php--pear--package"></a>`package`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--pear--manage_repos"></a>`manage_repos`

Data type: `Boolean`



Default value: `$php::manage_repos`

### <a name="php--phpunit"></a>`php::phpunit`

Install phpunit, PHP testing framework

=== Parameters

[*source*]
  Holds URL to the phpunit source file

[*path*]
  Holds path to the phpunit executable

[*auto_update*]
  Defines if phpunit should be auto updated

[*max_age*]
  Defines the time in days after which an auto-update gets executed

#### Parameters

The following parameters are available in the `php::phpunit` class:

* [`source`](#-php--phpunit--source)
* [`path`](#-php--phpunit--path)
* [`root_group`](#-php--phpunit--root_group)
* [`auto_update`](#-php--phpunit--auto_update)
* [`max_age`](#-php--phpunit--max_age)

##### <a name="-php--phpunit--source"></a>`source`

Data type: `String`



Default value: `$php::params::phpunit_source`

##### <a name="-php--phpunit--path"></a>`path`

Data type: `Stdlib::Absolutepath`



Default value: `$php::params::phpunit_path`

##### <a name="-php--phpunit--root_group"></a>`root_group`

Data type: `String[1]`



Default value: `$php::params::root_group`

##### <a name="-php--phpunit--auto_update"></a>`auto_update`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--phpunit--max_age"></a>`max_age`

Data type: `Integer`



Default value: `$php::params::phpunit_max_age`

### <a name="php--phpunit--auto_update"></a>`php::phpunit::auto_update`

Install phpunit package manager

=== Parameters

[*max_age*]
  Defines number of days after which phpunit should be updated

[*source*]
  Holds URL to the phpunit source file

[*path*]
  Holds path to the phpunit executable

#### Parameters

The following parameters are available in the `php::phpunit::auto_update` class:

* [`max_age`](#-php--phpunit--auto_update--max_age)
* [`source`](#-php--phpunit--auto_update--source)
* [`path`](#-php--phpunit--auto_update--path)

##### <a name="-php--phpunit--auto_update--max_age"></a>`max_age`

Data type: `Integer[1]`



##### <a name="-php--phpunit--auto_update--source"></a>`source`

Data type: `String[1]`



##### <a name="-php--phpunit--auto_update--path"></a>`path`

Data type: `Stdlib::Absolutepath`



### <a name="php--repo"></a>`php::repo`

Configure package repository

### <a name="php--repo--debian"></a>`php::repo::debian`

Configure debian apt repo

=== Parameters

[*location*]
  Location of the apt repository

[*repos*]
  Apt repository names

[*include_src*]
  Add source source repository

[*key*]
  Public key in apt::key format

[*dotdeb*]
  Enable special dotdeb handling

[*sury*]
  Enable special sury handling

#### Parameters

The following parameters are available in the `php::repo::debian` class:

* [`location`](#-php--repo--debian--location)
* [`repos`](#-php--repo--debian--repos)
* [`include_src`](#-php--repo--debian--include_src)
* [`key`](#-php--repo--debian--key)
* [`dotdeb`](#-php--repo--debian--dotdeb)
* [`sury`](#-php--repo--debian--sury)

##### <a name="-php--repo--debian--location"></a>`location`

Data type: `String[1]`



Default value: `'https://packages.dotdeb.org'`

##### <a name="-php--repo--debian--repos"></a>`repos`

Data type: `String[1]`



Default value: `'all'`

##### <a name="-php--repo--debian--include_src"></a>`include_src`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--repo--debian--key"></a>`key`

Data type: `Hash`



Default value:

```puppet
{
    'id'     => '6572BBEF1B5FF28B28B706837E3F070089DF5277',
    'source' => 'http://www.dotdeb.org/dotdeb.gpg',
  }
```

##### <a name="-php--repo--debian--dotdeb"></a>`dotdeb`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--repo--debian--sury"></a>`sury`

Data type: `Boolean`



Default value: `true`

### <a name="php--repo--redhat"></a>`php::repo::redhat`

The php::repo::redhat class.

#### Parameters

The following parameters are available in the `php::repo::redhat` class:

* [`yum_repo`](#-php--repo--redhat--yum_repo)

##### <a name="-php--repo--redhat--yum_repo"></a>`yum_repo`

Data type: `String[1]`



Default value: `'remi_php56'`

### <a name="php--repo--suse"></a>`php::repo::suse`

Configure suse repo

=== Parameters

[*reponame*]
  Name of the Zypper repository

[*baseurl*]
  Base URL of the Zypper repository

#### Parameters

The following parameters are available in the `php::repo::suse` class:

* [`reponame`](#-php--repo--suse--reponame)
* [`baseurl`](#-php--repo--suse--baseurl)

##### <a name="-php--repo--suse--reponame"></a>`reponame`

Data type: `String[1]`



Default value: `'mayflower-php56'`

##### <a name="-php--repo--suse--baseurl"></a>`baseurl`

Data type: `String[1]`



Default value: `'http://download.opensuse.org/repositories/home:/mayflower:/php5.6_based/SLE_11_SP3/'`

### <a name="php--repo--ubuntu"></a>`php::repo::ubuntu`

Configure ubuntu ppa

=== Parameters

[*version*]
  PHP version to manage (e.g. 5.6)

#### Parameters

The following parameters are available in the `php::repo::ubuntu` class:

* [`version`](#-php--repo--ubuntu--version)

##### <a name="-php--repo--ubuntu--version"></a>`version`

Data type: `Pattern[/^\d\.\d/]`



Default value: `'5.6'`

## Defined types

### <a name="php--apache_vhost"></a>`php::apache_vhost`

Configures an apache vhost for php

=== Parameters

[*vhost*]
  The vhost address

[*docroot*]
  The vhost docroot

[*port*]
  The vhost port

[*default_vhost*]
  defines if vhost is the default vhost

[*fastcgi_socket*]
  address of the fastcgi socket

#### Parameters

The following parameters are available in the `php::apache_vhost` defined type:

* [`vhost`](#-php--apache_vhost--vhost)
* [`docroot`](#-php--apache_vhost--docroot)
* [`port`](#-php--apache_vhost--port)
* [`default_vhost`](#-php--apache_vhost--default_vhost)
* [`fastcgi_socket`](#-php--apache_vhost--fastcgi_socket)

##### <a name="-php--apache_vhost--vhost"></a>`vhost`

Data type: `String[1]`



Default value: `'example.com'`

##### <a name="-php--apache_vhost--docroot"></a>`docroot`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/www'`

##### <a name="-php--apache_vhost--port"></a>`port`

Data type: `Integer[1]`



Default value: `80`

##### <a name="-php--apache_vhost--default_vhost"></a>`default_vhost`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--apache_vhost--fastcgi_socket"></a>`fastcgi_socket`

Data type: `String[1]`



Default value: `'fcgi://127.0.0.1:9000/$1'`

### <a name="php--config"></a>`php::config`

Configure php.ini settings for a PHP SAPI

=== Parameters

[*file*]
  The path to ini file

[*config*]
  Nested hash of key => value to apply to php.ini

=== Examples

  php::config { '$unique-name':
    file  => '$full_path_to_ini_file'
    config => {
      {'Date/date.timezone' => 'Europe/Berlin'}
    }
  }

#### Parameters

The following parameters are available in the `php::config` defined type:

* [`file`](#-php--config--file)
* [`config`](#-php--config--config)

##### <a name="-php--config--file"></a>`file`

Data type: `Stdlib::Absolutepath`



##### <a name="-php--config--config"></a>`config`

Data type: `Hash`



### <a name="php--config--setting"></a>`php::config::setting`

Configure php.ini settings

=== Parameters

[*key*]
  The key of the value, like `ini_setting`

[*file*]
  The path to ini file

[*value*]
  The value to set

=== Examples

  php::config::setting { 'Date/date.timezone':
    file  => '$full_path_to_ini_file'
    value => 'Europe/Berlin'
  }

#### Parameters

The following parameters are available in the `php::config::setting` defined type:

* [`key`](#-php--config--setting--key)
* [`file`](#-php--config--setting--file)
* [`value`](#-php--config--setting--value)

##### <a name="-php--config--setting--key"></a>`key`

Data type: `String[1]`



##### <a name="-php--config--setting--file"></a>`file`

Data type: `Stdlib::Absolutepath`



##### <a name="-php--config--setting--value"></a>`value`

Data type: `Optional[Variant[Integer, String]]`



Default value: `undef`

### <a name="php--extension"></a>`php::extension`

Install a PHP extension package

=== Parameters

[*ensure*]
  The ensure of the package to install
  Could be "present", "absent", "latest", "installed" or a pinned version

[*package_prefix*]
  Prefix to prepend to the package name for the package provider

[*package_name*]
  Full package name for the package provider (e.g. php7.2-xml for
  simlexml extension)

[*provider*]
  The provider used to install the package
  Could be "pecl", "apt", "dpkg" or any other OS package provider
  If set to "none", no package will be installed

[*source*]
  The source to install the extension from. Possible values
  depend on the *provider* used

[*so_name*]
  The DSO name of the package (e.g. opcache for zendopcache)

[*ini_prefix*]
  An optional filename prefix for the settings file of the extension

[*php_api_version*]
  This parameter is used to build the full path to the extension
  directory for zend_extension in PHP < 5.5 (e.g. 20100525)

[*header_packages*]
  System packages dependencies to install for extensions (e.g. for
  memcached libmemcached-dev on Debian)

[*compiler_packages*]
  System packages dependencies to install for compiling extensions
  (e.g. build-essential on Debian)

[*zend*]
 Boolean parameter, whether to load extension as zend_extension.
 Defaults to false.

[*settings*]
  Hash of parameters for the specific extension, which will be written to the extensions config file by
  php::extension::config or a hash of mutliple settings files, each with parameters
  (multifile_settings must be true)
  (f.ex. {p => '..'} or {'bz2' => {..}, {'math' => {...}})

[*multifile_settings*]
  Set this to true if you specify multiple setting files in *settings*. This must be used when the PHP package
  distribution bundles extensions in a single package (like 'common' bundles extensions 'bz2', ...) and each of
  the extension comes with a separate settings file.

[*settings_prefix*]
  Boolean/String parameter, whether to prefix all setting keys with
  the extension name or specified name. Defaults to false.

[*sapi*]
  String parameter, whether to specify ALL sapi or a specific sapi.
  Defaults to ALL.

[*responsefile*]
  File containing answers for interactive extension setup. Supported
  *providers*: pear, pecl.

[*install_options*]
  Array of String or Hash options to pass to the provider.

#### Parameters

The following parameters are available in the `php::extension` defined type:

* [`ensure`](#-php--extension--ensure)
* [`provider`](#-php--extension--provider)
* [`source`](#-php--extension--source)
* [`so_name`](#-php--extension--so_name)
* [`ini_prefix`](#-php--extension--ini_prefix)
* [`php_api_version`](#-php--extension--php_api_version)
* [`package_prefix`](#-php--extension--package_prefix)
* [`package_name`](#-php--extension--package_name)
* [`zend`](#-php--extension--zend)
* [`settings`](#-php--extension--settings)
* [`multifile_settings`](#-php--extension--multifile_settings)
* [`sapi`](#-php--extension--sapi)
* [`settings_prefix`](#-php--extension--settings_prefix)
* [`responsefile`](#-php--extension--responsefile)
* [`header_packages`](#-php--extension--header_packages)
* [`compiler_packages`](#-php--extension--compiler_packages)
* [`install_options`](#-php--extension--install_options)

##### <a name="-php--extension--ensure"></a>`ensure`

Data type: `String`



Default value: `$php::ensure`

##### <a name="-php--extension--provider"></a>`provider`

Data type: `Optional[Php::Provider]`



Default value: `undef`

##### <a name="-php--extension--source"></a>`source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--so_name"></a>`so_name`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--ini_prefix"></a>`ini_prefix`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--php_api_version"></a>`php_api_version`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--package_prefix"></a>`package_prefix`

Data type: `String`



Default value: `$php::package_prefix`

##### <a name="-php--extension--package_name"></a>`package_name`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--extension--zend"></a>`zend`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--extension--settings"></a>`settings`

Data type: `Variant[Hash, Hash[String, Hash]]`



Default value: `{}`

##### <a name="-php--extension--multifile_settings"></a>`multifile_settings`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--extension--sapi"></a>`sapi`

Data type: `Php::Sapi`



Default value: `'ALL'`

##### <a name="-php--extension--settings_prefix"></a>`settings_prefix`

Data type: `Variant[Boolean, String]`



Default value: `false`

##### <a name="-php--extension--responsefile"></a>`responsefile`

Data type: `Optional[Stdlib::AbsolutePath]`



Default value: `undef`

##### <a name="-php--extension--header_packages"></a>`header_packages`

Data type: `Variant[String, Array[String]]`



Default value: `[]`

##### <a name="-php--extension--compiler_packages"></a>`compiler_packages`

Data type: `Variant[String, Array[String]]`



Default value: `$php::params::compiler_packages`

##### <a name="-php--extension--install_options"></a>`install_options`

Data type: `Php::InstallOptions`



Default value: `undef`

### <a name="php--extension--config"></a>`php::extension::config`

Configure a PHP extension package

=== Parameters

[*ensure*]
  The ensure of the package to install
  Could be "latest", "installed" or a pinned version

[*provider*]
  The provider used to install the package
  Could be "pecl", "apt", "dpkg" or any other OS package provider
  If set to "none", no package will be installed

[*so_name*]
  The DSO name of the package (e.g. opcache for zendopcache)

[*ini_prefix*]
  An optional filename prefix for the settings file of the extension

[*php_api_version*]
  This parameter is used to build the full path to the extension
  directory for zend_extension in PHP < 5.5 (e.g. 20100525)

[*header_packages*]
  System packages dependencies to install for extensions (e.g. for
  memcached libmemcached-dev on Debian)

[*compiler_packages*]
  System packages dependencies to install for compiling extensions
  (e.g. build-essential on Debian)

[*zend*]
 Boolean parameter, whether to load extension as zend_extension.
 Defaults to false.

[*settings*]
  Nested hash of global config parameters for php.ini

[*settings_prefix*]
  Boolean/String parameter, whether to prefix all setting keys with
  the extension name or specified name. Defaults to false.

[*sapi*]
  String parameter, whether to specify ALL sapi or a specific sapi.
  Defaults to ALL.

#### Parameters

The following parameters are available in the `php::extension::config` defined type:

* [`ensure`](#-php--extension--config--ensure)
* [`provider`](#-php--extension--config--provider)
* [`so_name`](#-php--extension--config--so_name)
* [`ini_prefix`](#-php--extension--config--ini_prefix)
* [`php_api_version`](#-php--extension--config--php_api_version)
* [`zend`](#-php--extension--config--zend)
* [`settings`](#-php--extension--config--settings)
* [`settings_prefix`](#-php--extension--config--settings_prefix)
* [`sapi`](#-php--extension--config--sapi)

##### <a name="-php--extension--config--ensure"></a>`ensure`

Data type: `String`



Default value: `'installed'`

##### <a name="-php--extension--config--provider"></a>`provider`

Data type: `Optional[Php::Provider]`



Default value: `undef`

##### <a name="-php--extension--config--so_name"></a>`so_name`

Data type: `Optional[String]`



Default value: `downcase($name)`

##### <a name="-php--extension--config--ini_prefix"></a>`ini_prefix`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--config--php_api_version"></a>`php_api_version`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--config--zend"></a>`zend`

Data type: `Boolean`



Default value: `false`

##### <a name="-php--extension--config--settings"></a>`settings`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--extension--config--settings_prefix"></a>`settings_prefix`

Data type: `Variant[Boolean, String]`



Default value: `false`

##### <a name="-php--extension--config--sapi"></a>`sapi`

Data type: `Php::Sapi`



Default value: `'ALL'`

### <a name="php--extension--install"></a>`php::extension::install`

Install a PHP extension package

=== Parameters

[*ensure*]
  The ensure of the package to install
  Could be "latest", "installed" or a pinned version

[*package_prefix*]
  Prefix to prepend to the package name for the package provider

[*package_name*]
  Full package name for the package provider (e.g. php7.2-xml for
  simlexml extension)

[*provider*]
  The provider used to install the package
  Could be "pecl", "apt", "dpkg" or any other OS package provider
  If set to "none", no package will be installed

[*source*]
  The source to install the extension from. Possible values
  depend on the *provider* used

[*header_packages*]
  System packages dependencies to install for extensions (e.g. for
  memcached libmemcached-dev on Debian)

[*compiler_packages*]
  System packages dependencies to install for compiling extensions
  (e.g. build-essential on Debian)

[*responsefile*]
  File containing answers for interactive extension setup. Supported
  *providers*: pear, pecl.

[*install_options*]
  Array of String or Hash options to pass to the provider.

#### Parameters

The following parameters are available in the `php::extension::install` defined type:

* [`ensure`](#-php--extension--install--ensure)
* [`provider`](#-php--extension--install--provider)
* [`source`](#-php--extension--install--source)
* [`package_prefix`](#-php--extension--install--package_prefix)
* [`package_name`](#-php--extension--install--package_name)
* [`responsefile`](#-php--extension--install--responsefile)
* [`header_packages`](#-php--extension--install--header_packages)
* [`compiler_packages`](#-php--extension--install--compiler_packages)
* [`install_options`](#-php--extension--install--install_options)

##### <a name="-php--extension--install--ensure"></a>`ensure`

Data type: `String`



Default value: `'installed'`

##### <a name="-php--extension--install--provider"></a>`provider`

Data type: `Optional[Php::Provider]`



Default value: `undef`

##### <a name="-php--extension--install--source"></a>`source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-php--extension--install--package_prefix"></a>`package_prefix`

Data type: `String`



Default value: `$php::package_prefix`

##### <a name="-php--extension--install--package_name"></a>`package_name`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--extension--install--responsefile"></a>`responsefile`

Data type: `Optional[Stdlib::AbsolutePath]`



Default value: `undef`

##### <a name="-php--extension--install--header_packages"></a>`header_packages`

Data type: `Variant[String, Array[String]]`



Default value: `[]`

##### <a name="-php--extension--install--compiler_packages"></a>`compiler_packages`

Data type: `Variant[String, Array[String]]`



Default value: `$php::params::compiler_packages`

##### <a name="-php--extension--install--install_options"></a>`install_options`

Data type: `Php::InstallOptions`



Default value: `undef`

### <a name="php--fpm--pool"></a>`php::fpm::pool`

Configure fpm pools

=== Parameters

See the official php-fpm documentation for parameters that are not
documented here: http://php.net/manual/en/install.fpm.configuration.php.

[*ensure*]
  Remove pool if set to `'absent'`, add otherwise

[*listen*]
  On what socket to listen for FastCGI connections, i.e.
  `'127.0.0.1:9000'' or `'/var/run/php5-fpm.sock'`

[*listen_backlog*]

[*listen_allowed_clients*]

[*listen_owner*]
  Set owner of the Unix socket

[*listen_group*]
  Set the group of the Unix socket

[*listen_mode*]

[*user*]
  The user that php-fpm should run as

[*group*]
  The group that php-fpm should run as

[*apparmor_hat*]
  The Apparmor hat to use

[*pm*]

[*pm_max_children*]

[*pm_start_servers*]

[*pm_min_spare_servers*]

[*pm_max_spare_servers*]

[*pm_max_requests*]

[*pm_process_idle_timeout*]

[*pm_status_path*]

[*ping_path*]

[*ping_response*]

[*access_log*]
  The path to the file to write access log requests to

[*access_log_format*]
  The format to save the access log entries as

[*request_terminate_timeout*]

[*request_slowlog_timeout*]

[*security_limit_extensions*]

[*slowlog*]

[*template*]
  The template to use for the pool

[*rlimit_files*]

[*rlimit_core*]

[*chroot*]

[*chdir*]

[*catch_workers_output*]

[*include*]
  Other configuration files to include on this pool

[*env*]
  List of environment variables that are passed to the php-fpm from the
  outside and will be available to php scripts in this pool

[*env_value*]
  Hash of environment variables and values as strings to use in php
  scripts in this pool

[*clear_env*]
  Whether the environment should be cleared.

[*options*]
  An optional hash for any other data.

[*php_value*]
  Hash of php_value directives

[*php_flag*]
  Hash of php_flag directives

[*php_admin_value*]
  Hash of php_admin_value directives

[*php_admin_flag*]
  Hash of php_admin_flag directives

[*php_directives*]
  List of custom directives that are appended to the pool config

[*root_group*]
  UNIX group of the root user

[*base_dir*]
  The folder that contains the php-fpm pool configs. This defaults to a
  sensible default depending on your operating system, like
  '/etc/php5/fpm/pool.d' or '/etc/php-fpm.d'

#### Parameters

The following parameters are available in the `php::fpm::pool` defined type:

* [`ensure`](#-php--fpm--pool--ensure)
* [`listen`](#-php--fpm--pool--listen)
* [`listen_backlog`](#-php--fpm--pool--listen_backlog)
* [`listen_allowed_clients`](#-php--fpm--pool--listen_allowed_clients)
* [`listen_owner`](#-php--fpm--pool--listen_owner)
* [`listen_group`](#-php--fpm--pool--listen_group)
* [`listen_mode`](#-php--fpm--pool--listen_mode)
* [`user`](#-php--fpm--pool--user)
* [`group`](#-php--fpm--pool--group)
* [`apparmor_hat`](#-php--fpm--pool--apparmor_hat)
* [`pm`](#-php--fpm--pool--pm)
* [`pm_max_children`](#-php--fpm--pool--pm_max_children)
* [`pm_start_servers`](#-php--fpm--pool--pm_start_servers)
* [`pm_min_spare_servers`](#-php--fpm--pool--pm_min_spare_servers)
* [`pm_max_spare_servers`](#-php--fpm--pool--pm_max_spare_servers)
* [`pm_max_requests`](#-php--fpm--pool--pm_max_requests)
* [`pm_process_idle_timeout`](#-php--fpm--pool--pm_process_idle_timeout)
* [`pm_status_path`](#-php--fpm--pool--pm_status_path)
* [`ping_path`](#-php--fpm--pool--ping_path)
* [`ping_response`](#-php--fpm--pool--ping_response)
* [`access_log`](#-php--fpm--pool--access_log)
* [`access_log_format`](#-php--fpm--pool--access_log_format)
* [`request_terminate_timeout`](#-php--fpm--pool--request_terminate_timeout)
* [`request_slowlog_timeout`](#-php--fpm--pool--request_slowlog_timeout)
* [`security_limit_extensions`](#-php--fpm--pool--security_limit_extensions)
* [`slowlog`](#-php--fpm--pool--slowlog)
* [`template`](#-php--fpm--pool--template)
* [`rlimit_files`](#-php--fpm--pool--rlimit_files)
* [`rlimit_core`](#-php--fpm--pool--rlimit_core)
* [`chroot`](#-php--fpm--pool--chroot)
* [`chdir`](#-php--fpm--pool--chdir)
* [`catch_workers_output`](#-php--fpm--pool--catch_workers_output)
* [`include`](#-php--fpm--pool--include)
* [`env`](#-php--fpm--pool--env)
* [`env_value`](#-php--fpm--pool--env_value)
* [`clear_env`](#-php--fpm--pool--clear_env)
* [`options`](#-php--fpm--pool--options)
* [`php_value`](#-php--fpm--pool--php_value)
* [`php_flag`](#-php--fpm--pool--php_flag)
* [`php_admin_value`](#-php--fpm--pool--php_admin_value)
* [`php_admin_flag`](#-php--fpm--pool--php_admin_flag)
* [`php_directives`](#-php--fpm--pool--php_directives)
* [`root_group`](#-php--fpm--pool--root_group)
* [`base_dir`](#-php--fpm--pool--base_dir)

##### <a name="-php--fpm--pool--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

##### <a name="-php--fpm--pool--listen"></a>`listen`

Data type: `String[1]`



Default value: `'127.0.0.1:9000'`

##### <a name="-php--fpm--pool--listen_backlog"></a>`listen_backlog`

Data type: `Integer[-1]`



Default value: `-1`

##### <a name="-php--fpm--pool--listen_allowed_clients"></a>`listen_allowed_clients`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm--pool--listen_owner"></a>`listen_owner`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm--pool--listen_group"></a>`listen_group`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm--pool--listen_mode"></a>`listen_mode`

Data type: `Optional[Stdlib::Filemode]`



Default value: `undef`

##### <a name="-php--fpm--pool--user"></a>`user`

Data type: `String[1]`



Default value: `$php::fpm::config::user`

##### <a name="-php--fpm--pool--group"></a>`group`

Data type: `String[1]`



Default value: `$php::fpm::config::group`

##### <a name="-php--fpm--pool--apparmor_hat"></a>`apparmor_hat`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm--pool--pm"></a>`pm`

Data type: `String[1]`



Default value: `'dynamic'`

##### <a name="-php--fpm--pool--pm_max_children"></a>`pm_max_children`

Data type: `Integer[1]`



Default value: `50`

##### <a name="-php--fpm--pool--pm_start_servers"></a>`pm_start_servers`

Data type: `Integer[0]`



Default value: `5`

##### <a name="-php--fpm--pool--pm_min_spare_servers"></a>`pm_min_spare_servers`

Data type: `Integer[0]`



Default value: `5`

##### <a name="-php--fpm--pool--pm_max_spare_servers"></a>`pm_max_spare_servers`

Data type: `Integer[0]`



Default value: `35`

##### <a name="-php--fpm--pool--pm_max_requests"></a>`pm_max_requests`

Data type: `Integer[0]`



Default value: `0`

##### <a name="-php--fpm--pool--pm_process_idle_timeout"></a>`pm_process_idle_timeout`

Data type: `Php::Duration`



Default value: `'10s'`

##### <a name="-php--fpm--pool--pm_status_path"></a>`pm_status_path`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--fpm--pool--ping_path"></a>`ping_path`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--fpm--pool--ping_response"></a>`ping_response`

Data type: `String[1]`



Default value: `'pong'`

##### <a name="-php--fpm--pool--access_log"></a>`access_log`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--fpm--pool--access_log_format"></a>`access_log_format`

Data type: `String[1]`



Default value: `'"%R - %u %t \"%m %r\" %s"'`

##### <a name="-php--fpm--pool--request_terminate_timeout"></a>`request_terminate_timeout`

Data type: `Php::Duration`



Default value: `0`

##### <a name="-php--fpm--pool--request_slowlog_timeout"></a>`request_slowlog_timeout`

Data type: `Php::Duration`



Default value: `0`

##### <a name="-php--fpm--pool--security_limit_extensions"></a>`security_limit_extensions`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-php--fpm--pool--slowlog"></a>`slowlog`

Data type: `Stdlib::Absolutepath`



Default value: `"/var/log/php-fpm/${name}-slow.log"`

##### <a name="-php--fpm--pool--template"></a>`template`

Data type: `String[1]`



Default value: `'php/fpm/pool.conf.erb'`

##### <a name="-php--fpm--pool--rlimit_files"></a>`rlimit_files`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-php--fpm--pool--rlimit_core"></a>`rlimit_core`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-php--fpm--pool--chroot"></a>`chroot`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--fpm--pool--chdir"></a>`chdir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-php--fpm--pool--catch_workers_output"></a>`catch_workers_output`

Data type: `Enum['yes', 'no']`



Default value: `'no'`

##### <a name="-php--fpm--pool--include"></a>`include`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-php--fpm--pool--env"></a>`env`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-php--fpm--pool--env_value"></a>`env_value`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--clear_env"></a>`clear_env`

Data type: `Boolean`



Default value: `true`

##### <a name="-php--fpm--pool--options"></a>`options`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--php_value"></a>`php_value`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--php_flag"></a>`php_flag`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--php_admin_value"></a>`php_admin_value`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--php_admin_flag"></a>`php_admin_flag`

Data type: `Hash`



Default value: `{}`

##### <a name="-php--fpm--pool--php_directives"></a>`php_directives`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-php--fpm--pool--root_group"></a>`root_group`

Data type: `String[1]`



Default value: `$php::params::root_group`

##### <a name="-php--fpm--pool--base_dir"></a>`base_dir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

## Functions

### <a name="ensure_prefix"></a>`ensure_prefix`

Type: Ruby 3.x API

This function ensures a prefix for all elements in an array or the keys in a hash.

*Examples:*

  ensure_prefix({'a' => 1, 'b' => 2, 'p.c' => 3}, 'p.')

Will return:
  {
    'p.a' => 1,
    'p.b' => 2,
    'p.c' => 3,
  }

  ensure_prefix(['a', 'p.b', 'c'], 'p.')

Will return:
  ['p.a', 'p.b', 'p.c']

#### `ensure_prefix()`

This function ensures a prefix for all elements in an array or the keys in a hash.

*Examples:*

  ensure_prefix({'a' => 1, 'b' => 2, 'p.c' => 3}, 'p.')

Will return:
  {
    'p.a' => 1,
    'p.b' => 2,
    'p.c' => 3,
  }

  ensure_prefix(['a', 'p.b', 'c'], 'p.')

Will return:
  ['p.a', 'p.b', 'p.c']

Returns: `Any`

### <a name="to_hash_settings"></a>`to_hash_settings`

Type: Ruby 3.x API

This function converts a +{key => value}+ hash into a nested hash and can add an id to the outer key.
The optional id string as second parameter is prepended to the resource name.

*Examples:*

  to_hash_settings({'a' => 1, 'b' => 2})

Would return:
  {
    'a' => {'key' => 'a', 'value' => 1},
    'b' => {'key' => 'b', 'value' => 2}
  }

and:

  to_hash_settings({'a' => 1, 'b' => 2}, 'foo')

Would return:
  {
    'foo: a' => {'key' => 'a', 'value' => 1},
    'foo: b' => {'key' => 'b', 'value' => 2}
  }

#### `to_hash_settings()`

This function converts a +{key => value}+ hash into a nested hash and can add an id to the outer key.
The optional id string as second parameter is prepended to the resource name.

*Examples:*

  to_hash_settings({'a' => 1, 'b' => 2})

Would return:
  {
    'a' => {'key' => 'a', 'value' => 1},
    'b' => {'key' => 'b', 'value' => 2}
  }

and:

  to_hash_settings({'a' => 1, 'b' => 2}, 'foo')

Would return:
  {
    'foo: a' => {'key' => 'a', 'value' => 1},
    'foo: b' => {'key' => 'b', 'value' => 2}
  }

Returns: `Any`

## Data types

### <a name="Php--ComposerChannel"></a>`Php::ComposerChannel`

The Php::ComposerChannel data type.

Alias of `Enum['stable', 'preview', 'snapshot', '1', '2']`

### <a name="Php--Duration"></a>`Php::Duration`

A duration in seconds are with an unit

Alias of `Variant[Integer[0], Pattern[/^\d+[smhd]?$/]]`

### <a name="Php--InstallOptions"></a>`Php::InstallOptions`

The Php::InstallOptions data type.

Alias of

```puppet
Optional[Array[
    Variant[
      String,
      Hash[String, String]
    ]
  ]]
```

### <a name="Php--Provider"></a>`Php::Provider`

The Php::Provider data type.

Alias of `Enum['none', 'pecl', 'pear', 'dpkg', 'apt', 'yum', 'rpm', 'dnf', 'up2date', 'zypper', 'rug', 'freebsd', 'pkgng', 'ports', 'portupgrade']`

### <a name="Php--Sapi"></a>`Php::Sapi`

The Php::Sapi data type.

Alias of `Enum['ALL', 'cli', 'fpm', 'apache2']`

